use AdventureWorks2008R2
go

/* Format currency by culture */
declare @m money
select @m = 1000.99

select format(@m,'C')
select format(@m,'C','en-gb')
select format(@m,'C','fr-FR')
select format(@m,'C','de-DE')
select format(@m,'C','en-in')

go


go

create table #ExchangeRates
(
ExRateId integer identity Primary Key,
ExRate    decimal(10,5) not null,
CultureString char(5) not null
)
---

Insert into #ExchangeRates(ExRate,CultureString)
values (1.5,'en-us'),(2,'fr-fr'),(2,'de-DE')
go
Create table #Sales
(
SaleId integer identity Primary Key,
SaleTotal money not null  -- Value in GBP

)

insert into #Sales(SaleTotal)
values (100),(120),(150)
go



select  * ,FORMAT(#Sales.SaleTotal*ExRate,'C',#ExchangeRates.CultureString)
  from #Sales
  cross join #ExchangeRates

go
/* Format string limitations */

select format(1000.99,'Cost = C','en-gb')
go
select format(1000.99,'C ','en-gb')
go
select format(1000.99,' C','en-gb')
go

go
select format(11,'D') 
go
select format(11,'D4')
go
select format(11,'X') -- Hex Representation
go
select format(11,'X4')
go

DECLARE @d DATETIME = '2011-10-01';
SELECT FORMAT ( @d, 'd', 'en-US' ) AS Result;
SELECT FORMAT ( @d, 'd', 'en-gb' ) AS Result;
SELECT FORMAT ( @d, 'd', 'en-in' ) AS Result;


--FROM BOL 
--Use the FORMAT function for locale-aware formatting 
--of date/time and number values as strings. 
--For general type conversions, continue to use CAST or CONVERT


--PARSE  
-- TRY_CONVERT , TRY_PARSE
-- ISNUMERIC isnt good enough

select ISNUMERIC('1,2')
select cast('1,2' as numeric(10,3)) 
select TRY_CONVERT(numeric(10,3),'1,2')
select TRY_CONVERT(numeric(10,3),'1.2')



SELECT PARSE('Saturday, 1 october 2011' AS datetime2)
SELECT PARSE('Sunday, 1 october 2011' AS datetime2)


select Parse('Rs. 1,000.99' as money using 'en-in')
select Parse('1000,99 ' as money using 'fr-FR')
select Parse('1.000,99 ' as money using 'de-DE')

select TRY_PARSE('1,2' as numeric(10,3))

SELECT TRY_PARSE('Saturday, 1 october 2011' AS datetime2)
SELECT TRY_PARSE('Sunday, 1 october 2011' AS datetime2)

Select TRY_PARSE('01/10/2011' as date using 'en-gb')
Select TRY_PARSE('01/21/2011' as date using 'en-us')
Select TRY_PARSE('01/21/2011' as date using 'en-gb')


go


-- DATETIMEFROMPARTS (YYYY,MM,DD,HH,MM,SS,MS)
select DATETIMEFROMPARTS (2011,10,1,17,27,34,89)


-- DATEFROMPARTS(year, month,  day)
-- DATETIME2FROMPARTS (Transact-SQL)
-- DATETIMEOFFSETFROMPARTS (Transact-SQL)
-- SMALLDATETIMEFROMPARTS (Transact-SQL)
-- TIMEFROMPARTS (Transact-SQL)



---   END OF MONTH
--    No BOMONTH ??!
Select EOMONTH ('2011-10-01')
Select EOMONTH ('2011-10-01',1)


----  CONCAT
select Concat('Hello',' ','SqlBits')

declare @Today date =getdate()
Select Concat('Today is ',@Today)

Select Concat('Value is ',1.23)


Create Table #ConcatTest
(
	ColA integer,
	ColB varchar(10),
	ColC char(10),
	ColD numeric(8,3),
	ColE Date,
	ColF Money
)

Insert into #ConcatTest 
values (1,'Test 1','1234',10.99,'2011-10-01',56.65),
       (2,'Test 2','1  4',.99  ,'2011-12-01',NULL),
	   (4,'Test 6',NULL  ,.0   ,'2011-12-06',NULL)

go

Select cast(ColA as varchar(10))+'|'+
       ColB+'|'+
	   ColC+'|'+
	   cast(ColD as varchar(10))+'|'+
	   cast(ColE as varchar(10))+'|'+
	   cast(ColF as varchar(10))
  from #ConcatTest
go
set concat_null_yields_null off
go
Select cast(ColA as varchar(10))+'|'+
       ColB+'|'+
	   ColC+'|'+
	   cast(ColD as varchar(10))+'|'+
	   cast(ColE as varchar(10))+'|'+
	   cast(ColF as varchar(10))
  from #ConcatTest


/*
FROM BOL :

In a future version of SQL Server CONCAT_NULL_YIELDS_NULL 
will always be ON and any applications that explicitly set 
the option to OFF will generate an error.

Avoid using this feature in new development work, and plan to modify
 applications that currently use this feature.
 */

set concat_null_yields_null on
 go

select concat(ColA,'|',
              ColB,'|',
			  ColC,'|',
			  ColD,'|',
			  ColE,'|',
			  ColF,'|')
 from  #ConcatTest

/*  COLLATION */

select concat(ColA,'|',
              ColB Collate Latin1_General_100_CS_AS, '|',
			  ColC Collate Latin1_General_100_CS_AS, '|',
			  ColD,'|',
			  ColE,'|',
			  ColF,'|')
 from  #ConcatTest

 go

/*   Not a windowing function , yet ????!!*/
/*   Cant Concatenate Over rows , just columns */

Select concat(ColB) over (partition by ColA)
  from #ConcatTest
go



/*   Still need to use XML Method */
select 
(select ColB+',' as [text()]
from #ConcatTest
order by ColB 
for xml path('')) as ColBConcat
from (Select 1) as RowN(N)

go
